//include std lib if they havent been included
#ifndef STD_LIB_H
#define STD_LIB_H
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<stdbool.h>
#include<math.h>
#endif

#ifndef MENU_H
#define MENU_H
#include "menu.h"
#endif //MENU_H

#ifndef SORT_H
#define SORT_H
#include "sorting.h"
#endif // !SORT_H
#define PAGE_SIZE 20

//fucntions for menu
void list_items();
void search_item();
void self_help_sale_system();
void print_page(struct inventory db, int cur, int end,struct Map* map);
int normal_menu_user_choices();

//main of normal user
void normal_menu(){
    int choice = 0;
    do{
        system("cls");
        welcome_message();
        //the selection menu
        
        choice = normal_menu_user_choices();

        switch (choice)
        {
            case 1://List items
                list_items();
                break;
            case 2://Search item
                search_item();
                break;
            case 3://self help sale system
                self_help_sale_system();
                break;
            case 4://Exit
                break;
            default://invalid input ,should not happen,as it is already catch in above function
                printf("Invalid choice\n");
                break;
        }
    }while(choice != 4);
}

//universal functions for normal user
struct Map* sortItems(struct inventory db, int sort);
void show_item(struct inventory db,int index){
    system("cls");
    printf("Product: %s\n", db.row[index].product);
    printf("Catergory: %s\n", db.row[index].category);
    printf("Brand: %d\n", db.row[index].brand);
    printf("Price: $%lf\n", db.row[index].price);
    printf("Stock: %d\n", db.row[index].stock);
    printf("Barcode: %ld\n",db.row[index].barcode);
    printf("Press any key to return to the list\n");
    fflush(stdin);
    getchar();
    return;
}
int normal_menu_user_choices(){
    int choice;
    printf("Normal User Menu\n");
    printf("1. List items\n");
    printf("2. Search item\n");
    printf("3. Self help sale system\n");
    printf("4. Exit\n");
    printf("Enter your choice: ");
    scanf("%d", &choice);
    return choice;
}
void list_page(struct inventory db,struct Map* map,int row){//user for showing list result and search result
    int choice = -1;
    int page = 0;
    int page_size = PAGE_SIZE;
    int total_pages = ceil((double)row / page_size);
    do{

    //options
    system("cls");
    printf("0 exit\n");
    printf("1 sort name decending\n");
    printf("2 sort name ascending\n");
    printf("3 sort price decending\n");
    printf("4 sort price ascending\n");
    printf("5 sort band decending\n");
    printf("6 sort band ascending\n");
    printf("7 sort category decending\n");
    printf("8 sort category ascending\n");
    printf("List of items:\n");

    //print items
    if(page + 1 >= total_pages){
        print_page(db, page * page_size, row,map);
    }else{//sorted)
        print_page(db, page * page_size, (page + 1) * page_size,map);
    }

    //page control
    printf("%d next page\n", page_size+3);
    printf("%d previous page\n", page_size+4);
    printf("%d set page size\n", page_size+5);
    printf("%d/%d/%d(page size/page number/total)\n",page_size, page+1,total_pages);

    //prompt user to select an item
    bool valid = true; 
    do{
        printf("Enter your choice: ");
        scanf("%d", &choice);
        if(choice <=8 && choice > 0){
            printf("sorting...\n");
            map = sortItems(db,choice);
        }else if(choice == page_size+3 && page + 1 < total_pages){
            page++;
        }else if(choice == page_size+4 && page > 0){
            page--;
        }else if(choice == page_size+5){
            printf("Enter page size: ");
            scanf("%d", &page_size);
            total_pages = ceil(row / page_size);
        }else if(choice >= 9 && choice < row+9){
            show_item(db,choice - 9 + page_size*page);   
        }else if(choice != 0){
            printf("Invalid choice\n");
            valid = false;
        }
    }while(!valid);

    }while(choice != 0);
}
//print the list for the page
void print_page(struct inventory db, int cur, int end,struct Map* map){
    for (int i = cur; i < end; i++)
    {
        if(map != NULL){
            printf("%d item %d: %s\n", i + 9,i, db.row[map[i].key].product);
        }
        else{
            printf("%d item %d: %s\n", i + 9,i, db.row[i].product);
        }
    }
}
//list items


void list_items(){
    system("cls");
    welcome_message();
    //get the list of items from the database
    //print the list of items
    //prompt user to select an item
    //if user selects an item, display the item's details
    
    struct inventory db = read_db_invt();
    struct Map* map = NULL;
    list_page(db,map,db.db.row_count);
}

//for sorting
struct Map* sortItems(struct inventory db, int sort){
    struct Map *map = malloc(sizeof(struct Map) * db.db.row_count);
    for (int i = 0; i < db.db.row_count; i++){
        map[i].key = i;
        switch(sort){
            case 1:
            case 2:
                map[i].value = (void*)db.row[i].product;
                break;

            case 3:
            case 4:
                long price = db.row[i].price * 100;
                map[i].value = (void*)price;//presume there is no price contain  0.001
                break;
            case 5:
            case 6:
                map[i].value = (void*)db.row[i].brand;
                break;
            case 7:
            case 8:
                map[i].value = (void*)db.row[i].category;
                break;
        }
    }
    switch (sort){
        case 1:
        case 3:
        case 5:
        case 7:
            qsort(map, db.db.row_count, sizeof(struct Map), compare_decending);
            break;
        case 2:
        case 4:
        case 6:
        case 8:
            qsort(map, db.db.row_count, sizeof(struct Map), compare_ascending);
            break;
    }
    return map;
}



//search items
char* prompt_search();
struct Map* searchItems(struct inventory db, char* searchstr);
void search_item(){
    system("cls");
    welcome_message();
    //search for item
    //prompt user to select an item
    //if user selects an item, display the item's details
    struct inventory db = read_db_invt();
    struct Map* map = NULL;
    do{

    //options
    int breakout = 0;
    bool valid = false;
    do{
        system("cls");
        welcome_message();
        printf("0 exit\n");
        printf("1 search\n");
        printf("select your choice: ");
        scanf("%d", &breakout);
        fflush(stdin);
        if(breakout == 1 || breakout == 0){
            valid = true;
        }else{
            printf("Invalid choice\n");
        }
    }while(!valid);
    if(breakout == 0){
        break;
    }
    char* searchstr = prompt_search();
    printf("searching...\n");
    map = searchItems(db,searchstr);
    if(map[0].value > 0){
        list_page(db,map+1,map[0].value);//ofset map, as it is use to store the size
    }else{//empty search
        printf("No result found\n");
        printf("Press any key to continue\n");
        fflush(stdin);
        getchar();

    }
    }while(true);//break on top

}


char* prompt_search(){
    printf("Enter search string:(largest length 100) ");
    char* searchstr = malloc(sizeof(char) * 100);
    scanf("%s", searchstr);
    return searchstr;
}

struct Map* searchItems(struct inventory db, char* searchstr){
    struct Map* map = malloc(sizeof(struct Map) * (db.db.row_count+1));
    int k = 1;
    for (int i = 0; i < db.db.row_count; i++){
        map[k].key = i;
        if(strstr(db.row[i].product,searchstr) != NULL){
            
            map[k].value = (void*)db.row[i].product;
            k++;
        }
    }
    map[0].value = k-1;
    map[0].key = -1;
    return map;
}

//self help
typedef struct cart{//linked list
    struct inventory_row* row;//pointer to the row
    int quantity;//quantity of the item
    struct cart* next;
};

int self_choice();
struct cart* scan_barcode(struct cart* cart,struct inventory db);
struct cart* list_cart(struct cart* cart);
void self_help_sale_system(){
    system("cls");
    welcome_message();
    //scan barcode
    struct inventory db = read_db_invt();
    struct cart* cart = NULL;
    bool check = false;
    do{

    //options
    int breakout = 0;
    int choice = self_choice();
    switch (choice)
    {
    case 1:
        cart = scan_barcode(cart,db);
        check = true;
        break;
    case 2:
        cart = list_cart(cart);
        check = true;
    default:
        break;
    }
    }while(check);
}

int self_choice(){
    int choice = 0;
    bool valid = false;
    do{
        system("cls");
        welcome_message();
        printf("0 exit\n");
        printf("1 scan barcode\n");
        printf("2 cart\n");
        printf("3 checkout\n");
        printf("select an option: ");
        scanf("%d", &choice);
        if(choice <= 3 || choice >= 0){
            valid = true;
        }else{
            printf("Invalid choice\n");
        }
    }while(!valid);
    return choice;
}
//support for the linked list
struct cart* Cartappend(struct cart* cart,struct inventory_row* row,int quantity){
    if(cart == NULL){
        cart = malloc(sizeof(struct cart));
        cart->row = row;
        cart->quantity = quantity;
        cart->next = NULL;
    }else{
        struct cart* temp = cart;
        while(temp->next != NULL){
            temp = temp->next;
        }
        temp->next = malloc(sizeof(struct cart));
        temp->next->row = row;
        temp->next->quantity = quantity;
        temp->next->next = NULL;
    }
    return cart;
}

struct cart* Cartremove(struct cart* cart,int index){
    if (cart == NULL){
        return cart;
    }else{
        struct cart* temp = cart;
        if (index == 0){
            cart = cart->next;
            free(temp);
            return cart;
        }else{
            for (int i = 0; i < index-1; i++){
                temp = temp->next;
            }
            struct cart* new = temp->next->next;
            free(temp->next);
            temp->next = new;
            return cart;
        }
    }
}
struct cart* Cartupdate(struct cart* cart,int index,int quantity){
    if (cart == NULL){
        return cart;
    }else{
        struct cart* temp = cart;
        if (index == 0){
            cart->quantity = quantity;
            return cart;
        }else{
            for (int i = 0; i < index-1; i++){
                temp = temp->next;
            }
            temp->next->quantity = quantity;
            return cart;
        }
    }
}

//scan barcode
struct inventory_row* find_barcode(struct inventory db,long barcode);
long prompt_barcode();
struct cart* scan_barcode(struct cart* cart,struct inventory db){
   
    long barcode = prompt_barcode();
    printf("matching...\n");
    struct inventory_row* row = find_barcode(db,barcode);
    if(row != NULL){
        printf("product: %s\n",row->product);
        printf("price: %.2f\n",row->price);
        printf("Enter quantity: ");\
        int quantity = 0;
        scanf("%d", &quantity);
        if(quantity > 0){
            cart = Cartappend(cart,row,quantity);
    }else{//empty search
        printf("Unable to match or invalid input\n");

    }
    }while(true);//break on top
    return cart;
}


long prompt_barcode(){
    printf("Please scan the qr code(or input the barcode ) ");
    long barcode;
    scanf("%ld", barcode);
    return barcode;
}

struct inventory_row* find_barcode(struct inventory db,long barcode){
    struct inventory_row row;
    printf("s");
    for (int i = 0; i < db.db.row_count; i++){
    printf("s");
        printf("%ld\n",db.row[i].barcode);
        if(db.row[i].barcode == barcode){
            
            return &db.row[i];
        }
    }
    return (struct inventory_row*)NULL;
}


//list cart
struct cart* cart_control(struct cart* cart,int index);
struct cart* list_cart(struct cart* cart){
        int choice = 0;
    do{
        system("cls");
        welcome_message();
        double total_price = 0;
        int i=1;
        printf("0 exit\n");
        if(cart == NULL){
            printf("Cart is empty\n");
        }else{
            struct cart* temp = cart;
            while(temp != NULL){
                int qty = temp->quantity;
                double price = temp->row->price * qty;
                total_price += price;
                printf("%d product:%s price:$%lf qty:%d\n",i,temp->row->product,price,qty);
                temp = temp->next;
                i++;
            }
            printf("Total price: $%.2f\n",total_price);
        }
        do{
            printf("input the corrisponding value for more action\n");
            scanf("%d", &choice);
            if(choice >0 && choice <= i){
                cart = cart_control(cart,choice);
            }   
        }while(choice >0 && choice < i);
    }while(choice != 0);
    return cart;
}
struct cart* update_cart(struct cart* cart,int index);
struct cart* cart_control(struct cart* cart,int index){
    int choice = 0;
    do{
        system("cls");
        welcome_message();
        printf("0 exit\n");
        printf("1 remove\n");
        printf("2 edit quantity\n");
        bool check = false;
        do{
            scanf("%d", &choice);
            if(choice == 1){
                cart = Cartremove(cart,index-1);
                check = true;
            }else if(choice == 2){
                cart = update_cart(cart,index);
                check = true;
            }else if(choice != 0){
                printf("Invalid choice\n");
                check = false;
            }
        }while(!check);
    }while(choice != 0);
    return cart;
}

struct cart* update_cart(struct cart* cart,int index){
    system("cls");
    welcome_message();
    printf("enter the new quantity: ");
    int quantity = 0;
    scanf("%d", &quantity);
    if(quantity > 0){
        cart = Cartupdate(cart,index-1,quantity);
    }else if (quantity == 0){
        cart = Cartremove(cart,index-1);
    }else{
        printf("Invalid quantity\n");
    }
    return cart;
}
